@@ -9,12 +9,13 @@
*/
#include <libcflat.h>
#include <migrate.h>
+#include <asm/time.h>
-#define NR_MIGRATIONS 30
+#define NR_MIGRATIONS 15
int main(int argc, char **argv)
{
- report_prefix_push("migration");
+ report_prefix_push("migration harness");
if (argc > 1 && !strcmp(argv[1], "skip")) {
migrate_skip();
@@ -24,7 +25,16 @@ int main(int argc, char **argv)
for (i = 0; i < NR_MIGRATIONS; i++)
migrate_quiet();
- report(true, "simple harness stress");
+ report(true, "cooperative migration");
+
+ migrate_begin_continuous();
+ mdelay(2000);
+ migrate_end_continuous();
+ mdelay(1000);
+ migrate_begin_continuous();
+ mdelay(2000);
+ migrate_end_continuous();
+ report(true, "continuous migration");
}
report_prefix_pop();
@@ -60,3 +60,21 @@ void migrate_skip(void)
puts("Skipped VM migration (quiet)\n");
(void)getchar();
}
+
+void migrate_begin_continuous(void)
+{
+ puts("Begin continuous migration\n");
+ (void)getchar();
+}
+
+void migrate_end_continuous(void)
+{
+ /*
+ * Migration can split this output between source and dest QEMU
+ * output files, print twice and match once to always cope with
+ * a split.
+ */
+ puts("End continuous migration\n");
+ puts("End continuous migration (quiet)\n");
+ (void)getchar();
+}
@@ -11,3 +11,6 @@ void migrate_quiet(void);
void migrate_once(void);
void migrate_skip(void);
+
+void migrate_begin_continuous(void);
+void migrate_end_continuous(void);
@@ -125,15 +125,17 @@ qmp_events ()
filter_quiet_msgs ()
{
grep -v "Now migrate the VM (quiet)" |
+ grep -v "Begin continuous migration (quiet)" |
+ grep -v "End continuous migration (quiet)" |
grep -v "Skipped VM migration (quiet)"
}
seen_migrate_msg ()
{
if [ $skip_migration -eq 1 ]; then
- grep -q -e "Now migrate the VM" < $1
+ grep -q -e "Now migrate the VM" -e "Begin continuous migration" < $1
else
- grep -q -e "Now migrate the VM" -e "Skipped VM migration" < $1
+ grep -q -e "Now migrate the VM" -e "Begin continuous migration" -e "Skipped VM migration" < $1
fi
}
@@ -161,6 +163,7 @@ run_migration ()
src_qmpout=/dev/null
dst_qmpout=/dev/null
skip_migration=0
+ continuous_migration=0
mkfifo ${src_outfifo}
mkfifo ${dst_outfifo}
@@ -186,9 +189,12 @@ run_migration ()
do_migration || return $?
while ps -p ${live_pid} > /dev/null ; do
- # Wait for test exit or further migration messages.
- if ! seen_migrate_msg ${src_out} ; then
+ if [ ${continuous_migration} -eq 1 ] ; then
+ do_migration || return $?
+ elif ! seen_migrate_msg ${src_out} ; then
sleep 0.1
+ elif grep -q "Begin continuous migration" < ${src_out} ; then
+ do_migration || return $?
elif grep -q "Now migrate the VM" < ${src_out} ; then
do_migration || return $?
elif [ $skip_migration -eq 0 ] && grep -q "Skipped VM migration" < ${src_out} ; then
@@ -218,7 +224,7 @@ do_migration ()
# The test must prompt the user to migrate, so wait for the
# "Now migrate VM" or similar console message.
- while ! seen_migrate_msg ${src_out} ; do
+ while [ ${continuous_migration} -eq 0 ] && ! seen_migrate_msg ${src_out} ; do
if ! ps -p ${live_pid} > /dev/null ; then
echo > ${dst_infifo}
qmp ${dst_qmp} '"quit"'> ${dst_qmpout} 2>/dev/null
@@ -229,12 +235,32 @@ do_migration ()
sleep 0.1
done
+ if grep -q "Begin continuous migration" < ${src_out} ; then
+ if [ ${continuous_migration} -eq 1 ] ; then
+ echo > ${dst_infifo}
+ qmp ${dst_qmp} '"quit"'> ${dst_qmpout} 2>/dev/null
+ echo "ERROR: Continuous migration already begun." >&2
+ qmp ${src_qmp} '"quit"'> ${src_qmpout} 2>/dev/null
+ return 3
+ fi
+ continuous_migration=1
+ echo > ${src_infifo}
+ fi
+
# Wait until the destination has created the incoming and qmp sockets
while ! [ -S ${dst_incoming} ] ; do sleep 0.1 ; done
while ! [ -S ${dst_qmp} ] ; do sleep 0.1 ; done
if [ $skip_migration -eq 0 ] && grep -q "Skipped VM migration" < ${src_out} ; then
# May not get any migrations, exit to main loop for now...
+ # No migrations today, shut down dst in an orderly manner...
+ if [ ${continuous_migration} -eq 1 ] ; then
+ echo > ${dst_infifo}
+ qmp ${dst_qmp} '"quit"'> ${dst_qmpout} 2>/dev/null
+ echo "ERROR: Can't skip in continuous migration." >&2
+ qmp ${src_qmp} '"quit"'> ${src_qmpout} 2>/dev/null
+ return 3
+ fi
echo > ${dst_infifo}
qmp ${dst_qmp} '"quit"'> ${dst_qmpout} 2>/dev/null
echo > ${src_infifo} # Resume src and carry on.
@@ -266,8 +292,23 @@ do_migration ()
qmp ${src_qmp} '"quit"'> ${src_qmpout} 2>/dev/null
- # keypress to dst so getchar completes and test continues
- echo > ${dst_infifo}
+ # Should we end continuous migration?
+ if grep -q "End continuous migration" < ${src_out} ; then
+ if [ ${continuous_migration} -eq 0 ] ; then
+ echo "ERROR: Can't end continuous migration when not started." >&2
+ echo > ${dst_infifo}
+ qmp ${dst_qmp} '"quit"'> ${dst_qmpout} 2>/dev/null
+ qmp ${src_qmp} '"quit"'> ${src_qmpout} 2>/dev/null
+ return 3
+ fi
+ continuous_migration=0
+ echo > ${src_infifo}
+ fi
+
+ if [ ${continuous_migration} -eq 0 ]; then
+ # keypress to dst so getchar completes and test continues
+ echo > ${dst_infifo}
+ fi
# Wait for the incoming socket being removed, ready for next destination
while [ -S ${dst_incoming} ] ; do sleep 0.1 ; done
The cooperative migration protocol is very good to control precise pre and post conditions for a migration event. However in some cases its intrusiveness to the test program, can mask problems and make analysis more difficult. For example to stress test migration vs concurrent complicated memory access, including TLB refill, ram dirtying, etc., then the tight spin at getchar() and resumption of the workload after migration is unhelpful. This adds a continuous migration mode that directs the harness to perform migrations continually. This is added to the migration selftests, which also sees cooperative migration iterations reduced to avoid increasing test time too much. Signed-off-by: Nicholas Piggin <npiggin@gmail.com> --- common/selftest-migration.c | 16 +++++++++-- lib/migrate.c | 18 ++++++++++++ lib/migrate.h | 3 ++ scripts/arch-run.bash | 55 ++++++++++++++++++++++++++++++++----- 4 files changed, 82 insertions(+), 10 deletions(-)